unit untBoardCategory;

interface

uses
  Graphics, Classes, untOnlineBoard;

type
  TBoardCategory = class
  protected
    BoardList: TObject;
  public
    CategoryName: string;
    Color: TColor;
    Boards: TList;
    Opened: boolean;
    constructor Create(bl: TObject);
    destructor  Destroy; override;
    function AddBoard(const Server, BoardName, DisplayName: string): TOnlineBoard;
    function GetBoard(const Server, BoardName: string): TOnlineBoard;
  end;

implementation

uses
  untBoard, untGlobal, untBoard2ch, untBoardJBBS;

function TBoardCategory.GetBoard(const Server, BoardName: string): TOnlineBoard;
var
  i: integer;
  b: TOnlineBoard;

begin
  result := nil;
  for i := 0 to Boards.Count - 1 do
  begin
    b := TOnlineBoard(Boards[i]);
    // T[o[͕ʖ̂ŔrȂł̂낤
    // 
    // (b.Server = Server)
    if (b.BoardName = BoardName) then
    begin
      result := b;
      break;
    end;
  end;
end;

function TBoardCategory.AddBoard(const Server, BoardName, DisplayName: string): TOnlineBoard;
var
  newBoard: TOnlineBoard;
  bbs: TBBSType;

begin
  bbs := GetBBSType(Server);
  if bbs = bt2ch then
  begin
    newBoard := TBoard2ch.Create;
  end else if bbs = btJBBS then
  begin
    newBoard := TBoardJBBS.Create;
  end else
  begin
    newBoard := nil;
  end;
  newBoard.Server      := Server;
  newBoard.BoardName   := BoardName;
  newBoard.DisplayName := DisplayName;
  newBoard.BoardList   := BoardList;
  newBoard.Category    := self;
  Boards.Add(newBoard);
  result := newBoard;
end;

constructor TBoardCategory.Create(bl: TObject);
begin
  inherited Create;

  BoardList := bl;
  Boards := TList.Create;
end;

destructor TBoardCategory.Destroy;
var
  i: integer;

begin
  for i := 0 to Boards.Count - 1 do
  begin
    TBoard(Boards[i]).Free;
  end;
  Boards.Free;

  inherited;
end;

end.
