unit untLostTopics;

interface

uses
  Classes, IdComponent,
  untOnlineBoard, untTopic;

type
  TLostTopics = class(TOnlineBoard)
  private
  protected
    procedure HttpReceived(Sender: TObject); override;
    procedure HttpComplete(Sender: TObject); override;
    procedure HttpStatusChange(axSender: TObject;
                               const axStatus: TIdStatus;
                               const asStatusText: string); override;
  public
    procedure DownloadTopic(tp: TTopic; Sender: TObject); override;
    procedure MakeTopic(const Title,
                              PostName,
                              PostEmail,
                              PostBody: string); override;
    function PostArticle(Topic: TTopic; const PostName,
                                              PostEmail,
                                              PostBody: string): TThread; override;
    procedure SendTopicList; override;
  end;

implementation

uses
  untTopicBrowser;

procedure TLostTopics.MakeTopic(const Title,
                                      PostName,
                                      PostEmail,
                                      PostBody: string);
begin
end;

function TLostTopics.PostArticle(Topic: TTopic; const PostName,
                                                      PostEmail,
                                                      PostBody: string): TThread;
begin
  result := nil;
end;

procedure TLostTopics.SendTopicList;
begin
  if Assigned(OnReceived) then
  begin
    OnReceived(self);
  end;
  if Assigned(OnComplete) then
  begin
    OnComplete(self);
  end;
end;

procedure TLostTopics.HttpReceived(Sender: TObject);
begin
end;

procedure TLostTopics.HttpComplete(Sender: TObject);
begin
end;

procedure TLostTopics.HttpStatusChange(axSender: TObject;
                                 const axStatus: TIdStatus;
                                 const asStatusText: string);
begin
end;

procedure TLostTopics.DownloadTopic(tp: TTopic; Sender: TObject);
var
  topicBrowser: TTopicBrowser;

begin
  if Sender is TTopicBrowser then
  begin
    topicBrowser := TTopicBrowser(Sender);
    topicBrowser.Topic := tp;
    tp.OnStateChange := topicBrowser.Topic_ChangeDownloadState;
    tp.OnReceived    := topicBrowser.Topic_MessageReceived;
    tp.OnComplete    := topicBrowser.Topic_Complete;
  end;
  tp.IsOpened := true;
  tp.LoadDat;
  tp.NewMessageCount := 0;
  tp.State := dsFreezed;
  tp.State := dsNone;
  if Assigned(tp.OnComplete) then
  begin
    tp.OnComplete(self);
  end;
end;

end.
